//---------------------------------------------------------------------------


#pragma hdrstop

#include "vcl_AutoCompleteEdit.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------

namespace Autocompleteedit
{
void __fastcall PACKAGE Register()
{
	TComponentClass classes[1] =
	{
		__classid(TAutoCompleteEdit)
	};
	RegisterComponents("Standard", classes, 0);
}
}

//---------------------------------------------------------------------------

void __fastcall TPopupListBox::CreateParams(TCreateParams& Prms)
{
	TListBox::CreateParams(Prms); 
	Prms.Style |= WS_BORDER; 
	Prms.ExStyle |= WS_EX_PALETTEWINDOW; 
	Prms.WindowClass.style |= CS_SAVEBITS;
}

//---------------------------------------------------------------------------

void __fastcall TPopupListBox::CreateWnd()
{
	TListBox::CreateWnd(); 
	::SetParent(WindowHandle, GetDesktopWindow());
}

//---------------------------------------------------------------------------

void __fastcall TPopupListBox::MouseMove(TShiftState Shift, int X, int Y)
{
	TListBox::MouseMove(Shift, X, Y); 

	//   ,   
	//    
	const int index = ItemAtPos(Point(X, Y), false); 
	if(index != -1)
	{
		//    
		ItemIndex = index;
	}
}

//---------------------------------------------------------------------------

void __fastcall TPopupListBox::MouseUp(TMouseButton Button, TShiftState Shift, int X,
	int Y)
{
	TListBox::MouseUp(Button, Shift, X, Y); 

	//   ,   
	//    
	const int index = ItemAtPos(Point(X, Y), true); 
	if(index != -1)
	{
		if(Edit_ != NULL)
		{
			//    
			Edit_->Text = Items->Strings[index]; 
			Edit_->SelectAll();
		} 
		//    
		Hide();
	}
}

//---------------------------------------------------------------------------

__fastcall TAutoCompleteEdit::TAutoCompleteEdit(TComponent* Owner)
	: TEdit(Owner), Strings_(new TStringList())
{
	Strings_->Sorted = true; 
	Strings_->CaseSensitive = false; 
	Strings_->Duplicates = dupIgnore; 

	if(!Designing())
	{
		//    
		PopupListBox_ = new TPopupListBox(this); 
		PopupListBox_->Parent = this;
		PopupListBox_->Edit = this;
	} 

	//  ,    
	//     . 
	//  Designing (), 
	//   2,   , 
	//     
	// ( true =  , 
	// false =  ). 
}

//---------------------------------------------------------------------------

void TAutoCompleteEdit::DoUpdatePopupList() 
{ 
	 //       
		if (Designing()) return; 

	//    
	PopupListBox_->Items->Clear(); 
	//     
	const AnsiString edit_text(Text); 

	//     Strings _ 
	const int count = Strings_->Count; 
	for(int idx = 0; idx < count; ++idx)
	{
		const AnsiString S(Strings_->Strings[idx]); 
		//      
		//    ( S )  Strings _ 
		if(S.Pos(edit_text) == 1)
		{
			//  S    
			PopupListBox_->Items->Add(S);
		}
	} 

	//        , 
	//       
	DoPopupList(PopupListBox_->Count > 0);
}

//---------------------------------------------------------------------------

void TAutoCompleteEdit::DoPopupList(bool show)
{
	if(!show)
	{
		//      
		PopupListBox_->Hide();
	} else
	{
		RECT R; 
		//   , 
		//    
		if(GetWindowRect(WindowHandle, &R))
		{
			PopupListBox_->Left = R.left; 
			PopupListBox_->Top = R.bottom; 
			PopupListBox_-> 
			Width = R.right - R.left; 

			//    
			PopupListBox_->Show();
		}
	}
}

//---------------------------------------------------------------------------

void __fastcall TAutoCompleteEdit::WMKillFocus(TMessage& Msg)
{
	TEdit::Dispatch(&Msg); 
	DoPopupList(false);
}

//---------------------------------------------------------------------------

void __fastcall TAutoCompleteEdit::KeyPress(char& Key)
{
	//     Enter, 
	//       , 
	//       
	if(Key == '\r' && !Designing() && PopupListBox_->Visible)
	{
		const int index = PopupListBox_->ItemIndex; 
		if(index != -1)
		{
			//    
			Text = PopupListBox_-> 
			Items->Strings[index]; 
			SelectAll();
		} 
		//    
		DoPopupList(false);
	} 
	TEdit::KeyPress(Key);
}

//---------------------------------------------------------------------------

void __fastcall TAutoCompleteEdit::KeyDown(Word& Key, TShiftState Shift)
{
	TEdit::KeyDown(Key, Shift); 
	if((Key == VK_UP || Key == VK_DOWN) && !Designing())
	{
		SNDMSG(PopupListBox_->Handle, WM_KEYDOWN, Key, 0);
	}
}

//---------------------------------------------------------------------------

void __fastcall TAutoCompleteEdit::Change()
{
	TEdit::Change(); 
	DoUpdatePopupList();
}

//---------------------------------------------------------------------------

